unit Hauptunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls ;

type
  TDatensatz = array [0..20000] of word;  //

  TSeminar = class(TForm)
    BTStart: TButton;
    EditAnzahl: TEdit;
    LabelAnzahl: TLabel;
    BTClose: TBitBtn;
    EditBubbleZaehler: TEdit;
    Label1: TLabel;
    ComboUhr: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    RGAuswahl: TRadioGroup;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditSelectZeit: TEdit;
    EditSelectZaehler: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    EditBubbleZeit: TEdit;
    EditLinearZeit: TEdit;
    EditLinearZahl: TEdit;
    editWiederholung: TEdit;
    Label10: TLabel;
    Label12: TLabel;
    EditbinaerZahl: TEdit;
    EditBinaerZeit: TEdit;
    Editgesucht: TEdit;
    Label13: TLabel;
    EditInsertZeit: TEdit;
    EditInsertZahl: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    procedure BTStartClick(Sender: TObject);
  private
    procedure Werteholen(sender: TObject);

    procedure BubbleSort(Sender: TObject);
    procedure BubbleAusgabe(Sender: TObject);

    procedure SelectSort(sender: TObject);
    procedure SelectAusgabe(Sender: TObject);

    procedure InsertSort(Sender: TObject);
    procedure InsertAusgabe(Sender: TObject);

    procedure zeitangabe(Sender: TObject);
    procedure FelderLoeschen(sender: TObject);

    procedure Zufall(Sender: TObject);
    procedure Aufsteigend(Sender: TObject);
    procedure Absteigend(sender: TObject);

    procedure StartSuchen(Sender: TObject);

    Procedure GesuchteZahl(sender: TObject);
    procedure LineareSuche(sender: TObject);
    procedure LinearAusgabe(Sender: TObject);

    procedure BinaereSuche(Sender: TObject);
    procedure BinaereAusgabe(Sender: TObject);
    procedure BinaerIterativ(liste: TDatensatz; anzahl : integer);

    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Seminar: TSeminar;
  Liste : TDatensatz; // Datensatz der Liste
  sichern : TDatensatz;  // gesicherte Liste
  anzahl : integer; //  Anzahl der Werte

  Uhr          : integer;
  bubbletimer1 : TDateTime; // Timer fr Start (Bubble-Sort)
  bubbletimer2 : TDatetime; //Timer fr Stop (Bubble-Sort)
  bubblezaehler : longint; //zhlt die Schleifendurchlufe beim Sortieren

  selecttimer1 : TDatetime; // 1. Timer fr Select-Sort
  selecttimer2 : TDatetime; // 2. Timer fr Select-Sort
  selectzaehler : longint; // zhlt die Durchlufe

  inserttimer1 : TDatetime; // 1. Timer fr Insertion-Sort
  inserttimer2 : Tdatetime; // 2. Timer fr Insertion-Sort
  insertzaehler : integer; // zhlt die Durchlufe

  lineartimer1 : TDatetime; // 1. Timer fr Lineare Suche
  lineartimer2 : TDatetime; // 2. Timer fr Lineare Suche

  Binaertimer1 : TDatetime; // 1. Timer fr Binre Suche
  Binaertimer2 : TDatetime; // 2. Timer fr Binre Suche


  gesucht : integer; // Zahl die gesucht wird
  BinaerZahl : integer; // Zahl, die bei der Binaeren Such gefunden worden ist

  wiederholung : integer; // gibt an, wie oft die Suche wiederholt wird


implementation

{$R *.DFM}
//Procedure Werteholen
//in der Prozedur wird ausgesucht, wie die Werte zugeordnet werden
procedure TSeminar.Werteholen(Sender: TObject);

begin
  case RGAuswahl.ItemIndex of
  0   :  Zufall(Sender);

  1   :  Aufsteigend(sender);

  2   :  Absteigend(Sender);

  end;
  sichern:=liste;
end;

//Werte werden zufllig zugeordnet
procedure TSeminar.Zufall(sender: TObject);
var i : longint;
begin
  randomize;
  for i:=1 to anzahl do
     liste[i]:=random(65000);
end;

// Werte werden aufsteigend sortiert zugeordnet
procedure TSeminar.Aufsteigend(Sender: TObject);
var I: longint;
begin
  for I:=1 to anzahl do
    liste[i]:=i;
end;

//Werte werden absteigend sortiert zugeordnet
procedure TSeminar.absteigend(Sender: TObject);
var i : integer;
begin
    for I:=1 to 10 do
    liste[i]:=11-i;
end;

// Procedure BTStartClick
// Anfangsprozedur - von hier werden alle Routinen gestartet
procedure TSeminar.BTStartClick(Sender: TObject);
begin
  FelderLoeschen(Sender); // alle Edit-Felder werden gelscht
  if StrToInt(EditAnzahl.Text) > 25000 then // berprfung der Anzahl von Werten, max. 25000
  showmessage('Bitte Anzahl nicht grer als 25000 whlen')
  else
  begin
    anzahl:=StrToInt(EditAnzahl.text);
    zeitangabe(sender);
    Werteholen(Sender);
    // BEGIN (Bubble-Sort)
    bubbletimer1:=time;
    BubbleSort(Sender);
    bubbletimer2:=time;
    BubbleAusgabe(Sender);
    // END (Bubble-Sort)
    liste:=sichern ;
    //Begin (Selection-Sort)
    selecttimer1:=time;
    SelectSort(sender);
    selecttimer2:=time;
    SelectAusgabe(Sender);
    // END (Selection-Sort)
    liste:=sichern;
    // Begin (Insertion-Sort)
    inserttimer1:=time;
    insertSort(sender);
    inserttimer2:=time;
    InsertAusgabe(Sender);
    // END (Insertion-Sort)
    StartSuchen(Sender); // Start der Suchroutinen
    showmessage('-                  Fertig !!!                  -');
  end;
End;

//Procedure BubbleSort
//die Reine Sortierfunktion
procedure TSeminar.BubbleSort(Sender: TObject);
var i,j : longint;
    hilfe : word;

begin
  bubblezaehler:=0;
  for i:=2 to anzahl do
  begin
    for j:=1 to anzahl-1  do
    begin
      if liste[j] >= liste[j+1] then
      begin
        hilfe:=liste[j];
        liste[j]:=liste[j+1];
        liste[j+1]:=hilfe;
      end;
    end;
    bubblezaehler:=bubblezaehler+1;
  end;
end;

//werte werden ausgegeben
Procedure TSeminar.BubbleAusgabe(Sender: TObject);
begin
    EditBubbleZeit.Text:=TimeToSTr((BubbleTimer2-BubbleTimer1)*uhr);
    EditBubbleZaehler.Text:=IntToStr(BubbleZaehler);
end;

//Procedure SelectSort
//die Reine Sortierfunktion
procedure TSeminar.SelectSort(Sender: TObjecT);
var i ,k , x, j   : integer;

begin
   SelectZaehler:=1;
   for i := 1 to anzahl - 1 do
   begin
   inc(SelectZaehler);
        k := i;
        x := liste[i];
        for j := i + 1 to anzahl do
           if liste[j] < x then
           begin
              k := j;
              x := liste[j];
           end;
        liste[k] := liste[i];
        liste[i] := x;
        end;
end;

//Werte werden ausgegeben
procedure TSeminar.SelectAusgabe(Sender: TObject);
begin
  EditSelectZeit.Text:=TimeToSTr((SelectTimer2-SelectTimer1)*uhr);
  EditSelectZaehler.Text:=IntToStr(SelectZaehler);
end;

//Procedure Insertion-Sort
//die Reine Sortierfunktion
procedure TSeminar.InsertSort(sender: TObject);
var i,j : integer;
    x : integer;
    hilfe : TDatensatz;
begin
     insertzaehler:=0;
     for i := 2 to anzahl   do
           begin
                  inc(insertzaehler);
                  x := liste[i];
                  liste[0] := x;
                  j := i - 1;
                  while x < liste[j] do
                  begin
                          liste[j + 1] := liste[j];
                          j := j - 1;
                  end;
                  liste[j + 1] := x;
          end;
     liste[0]:=0;

end;

//Werte werden ausgegeben
procedure TSeminar.InsertAusgabe(Sender: TObject);
begin
  EditInsertZeit.Text:=TimeToSTr((insertTimer2-InsertTimer1)*uhr);
  EditInsertZahl.Text:=IntToStr(InsertZaehler);
end;

// die Zeitangabe wird berechnet und die Variable Uhr gesetzt
procedure TSeminar.zeitangabe(sender: TObject);
begin
if combouhr.text = '1' then
  uhr:= 1;
If ComboUhr.Text = '1/10' then
  uhr:= 10;
If ComboUhr.text = '1/100' then
  uhr:= 100;
If ComboUhr.Text = '1/1000' then
  uhr:= 1000;
if comboUhr.Text = '1/10000' then
  uhr:= 10000;
end;

//alle Felder der Oberflche werden gelscht
procedure TSeminar.FelderLoeschen(Sender: TObject);

begin
 EditBubbleZeit.Text := ' ';
 EditBubbleZaehler.Text := ' ';
 EditSelectZeit.Text := ' ';
 EditSelectZaehler.Text := ' ';
 EditLinearZeit.Text := ' ';
 EditLinearZahl.Text := ' ';
 EditBinaerZeit.Text := ' ';
 EditBinaerZahl.Text := ' ';
 EditInsertZeit.Text := ' ';
 EditInsertZahl.Text := ' ';
 Editgesucht.Text:= ' ';
 refresh;
end;

// Startet beide Suchprozeduren
// holt die gesuchte Zahl "gesucht"

procedure TSeminar.StartSuchen(Sender: TObject);
var i,j : integer;
begin
  liste:=sichern;
  wiederholung:=StrToInt(EditWiederholung.Text);
  GesuchteZahl(sender);
  lineartimer1:=time;
  for I:=1 to wiederholung do
     LineareSuche(sender);
  lineartimer2:=time;
  LinearAusgabe(Sender);
  Binaertimer1:=time;
  for i:=1 to wiederholung do
    BinaereSuche(Sender);
  Binaertimer2:=time;
  BinaereAusgabe(sender);

end;

//sucht sich eine Zahl aus dem Array, durch Zufall
procedure TSeminar.GesuchteZahl(sender: Tobject);
var i: integer;
begin
  randomize;
  i:=random(anzahl-1);

  gesucht:=sichern[i];
end;

//Procedure LineareSuche
//die Reine Suchprozedur
procedure TSeminar.LineareSuche(Sender: TObject);
var i: integer;
    gefunden : boolean; // Boolean der auf True gesetzt wird, wenn die Zahl gefunden worden ist
begin
  gefunden:=false;
  i:=1;
  while (i<anzahl) and (gefunden=false) do
  begin
    if liste[i] = gesucht then
    begin
      EditlinearZahl.Text:=IntToStr(liste[i]);
      gefunden:=true;
    end;
  i:=i+1;
  end;
end;

// Ausgabe der Werte
procedure TSeminar.LinearAusgabe(Sender: TObject);
begin
  EditLinearZeit.Text:=TimeToStr((lineartimer2-lineartimer1)*Uhr);
end;

//Procedure BinaereSuche
// whlt aus, ob jedes Mal neu Sortiert werden soll
// und ruft dann BinaerIterativ auf
procedure TSeminar.BinaereSuche(Sender: TObject);
var i : integer;
    gefunden : boolean;
    SelectZaehler : integer;
begin
  i:=1;
  BinaerIterativ(liste,anzahl)
end;

//Procedure BinaerIterativ
//hier wird der Wert gesucht
procedure TSeminar.BinaerIterativ(liste: TDatensatz; anzahl : integer);
var i,hilfe : integer;
    low, high : integer;
    gefunden : boolean;
begin
  low := 1;
  high := anzahl;
  gefunden := false;
  while (low+1 < high) and (gefunden = false) do
  begin
    I := (low+high) div 2;
    if liste[i] = gesucht then gefunden := true
    else if liste[i] < gesucht then low := i+1
      else if liste[i] > gesucht then high := i-1;
  end;
end;

// Ausgabe der Werte
Procedure TSeminar.BinaereAusgabe(Sender: TObject);
begin
   EditBinaerZeit.Text:=TimeToStr((binaertimer2-binaertimer1)*uhr);
   EditBinaerZahl.Text:=IntToStr(gesucht);
   Editgesucht.Text:=IntToStr(gesucht);
   refresh;
end;

end.
